commit:     952353d284a8d5c79054ca1e80b4d501e0516a9b
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Sun May 11 18:29:49 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sun May 11 18:35:16 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=952353d2

dev-python/zstandard: enable py3.14

Signed-off-by: Sam James <sam <AT> gentoo.org>

 .../zstandard/files/zstandard-0.23.0-py314.patch   | 17 +++++
 dev-python/zstandard/zstandard-0.23.0-r3.ebuild    | 83 ++++++++++++++++++++++
 2 files changed, 100 insertions(+)

diff --git a/dev-python/zstandard/files/zstandard-0.23.0-py314.patch 
b/dev-python/zstandard/files/zstandard-0.23.0-py314.patch
new file mode 100644
index 000000000000..a2eb41c74060
--- /dev/null
+++ b/dev-python/zstandard/files/zstandard-0.23.0-py314.patch
@@ -0,0 +1,17 @@
+https://github.com/indygreg/python-zstandard/issues/238
+https://github.com/indygreg/python-zstandard/pull/262
+https://src.fedoraproject.org/rpms/python-zstandard/blob/rawhide/f/python-zstandard-py314.patch
+--- a/zstandard/__init__.py
++++ b/zstandard/__init__.py
+@@ -18,7 +18,10 @@ import io
+ import os
+ import platform
+ 
+-from typing import ByteString
++try:
++    from typing import ByteString
++except ImportError:
++    from collections.abc import Buffer as ByteString
+ 
+ # Some Python implementations don't support C extensions. That's why we have
+ # a CFFI implementation in the first place. The code here import one of our

diff --git a/dev-python/zstandard/zstandard-0.23.0-r3.ebuild 
b/dev-python/zstandard/zstandard-0.23.0-r3.ebuild
new file mode 100644
index 000000000000..d27fcf07d860
--- /dev/null
+++ b/dev-python/zstandard/zstandard-0.23.0-r3.ebuild
@@ -0,0 +1,83 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+DISTUTILS_EXT=1
+DISTUTILS_USE_PEP517=setuptools
+PYTHON_COMPAT=( python3_{10..14} pypy3 pypy3_11 )
+
+inherit distutils-r1
+
+MY_P=python-zstandard-${PV}
+DESCRIPTION="Zstandard Bindings for Python"
+HOMEPAGE="
+       https://github.com/indygreg/python-zstandard/
+       https://pypi.org/project/zstandard/
+"
+SRC_URI="
+       https://github.com/indygreg/python-zstandard/archive/${PV}.tar.gz
+               -> ${MY_P}.gh.tar.gz
+"
+S=${WORKDIR}/${MY_P}
+
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos 
~x64-solaris"
+
+DEPEND="
+       >=app-arch/zstd-1.5.7:=
+"
+RDEPEND="
+       ${DEPEND}
+       $(python_gen_cond_dep '
+               >=dev-python/cffi-1.14.0-r2:=[${PYTHON_USEDEP}]
+       ' 'python*')
+"
+BDEPEND="
+       test? (
+               dev-python/hypothesis[${PYTHON_USEDEP}]
+       )
+"
+
+distutils_enable_tests pytest
+
+src_prepare() {
+       local PATCHES=(
+               # https://github.com/indygreg/python-zstandard/pull/255
+               "${FILESDIR}/${P}-zstd-1.5.7.patch"
+               # https://github.com/indygreg/python-zstandard/pull/262
+               "${FILESDIR}/${P}-py314.patch"
+       )
+
+       # the C backend is repeatedly broken, so force CFFI instead
+       sed -e '/PYTHON_ZSTANDARD_IMPORT_POLICY/s:default:cffi:' \
+               -i zstandard/__init__.py || die
+       # unbundle zstd
+       rm zstd/* || die
+       > zstd/zstd.c || die
+       # it does random preprocessing on that, so we can't use #include
+       local f
+       for f in zdict.h zstd.h; do
+               cp "${ESYSROOT}/usr/include/${f}" "zstd/${f}" || die
+       done
+       sed -i -e '/include_dirs/a    libraries=["zstd"],' make_cffi.py || die
+
+       distutils-r1_src_prepare
+
+       DISTUTILS_ARGS=(
+               --no-c-backend
+       )
+}
+
+python_test() {
+       local EPYTEST_DESELECT=(
+               # unreliable, fails on x86
+               
tests/test_data_structures.py::TestCompressionParameters::test_estimated_compression_context_size
+               # check for bundled zstd version, fails on other system zstd
+               
tests/test_module_attributes.py::TestModuleAttributes::test_version
+       )
+
+       rm -rf zstandard || die
+       epytest
+}

Reply via email to